/*******************************************************************************
Desarrollado por: Avanxo México
Autor: Samuel Galindo
Proyecto: Toyota-Incentivos
Descripción: Clase para el desencadenador(Trigger) IN_ListaNegra_tgr para el
proceso de lista negra en el cual realizará una busqueda en el objeto Cuenta,
en caso de encontrar al cliente cambiará el status a "Boletinado", en caso
contrario va a crear la cuenta

-------------------------------------
No.    Fecha      Autor                      Descripción
------ ---------- -------------------------- -----------
0.1    25-04-2019 Samuel Galindo             Creación
0.2    26-04-2019 Samuel Galindo             Proceso Validación
0.3    29-04-2019 Samuel Galindo             Proceso Boletinado
0.4    30-04-2019 Samuel Galindo             Modificación Proceso Validación
0.5    02-05-2019 Samuel Galindo             Modificación Proceso Validación
0.6    05-05-2019 Samuel Galindo             Modificación Proceso Boletinado Previamente
0.7    06-05-2019 Samuel Galindo             Modificación Proceso Boletinado Previamente y Activo
0.8    13-05-2019 Samuel Galindo             Mejora código
0.9    04-07-2019 Héctor Figueroa            Mejora código
0.10   19-09-2019 Héctor Figueroa            Mejora código
0.11   06-04-2021 Cecilia Morán              Se Agrego al proceso funcionlidad y vaidación de nuevos tipos de registro.
*******************************************************************************/
public class IN_ListaNegraHandler_cls {

  // Registros Nuevos
  final List<IN_Reporte_de_Listas_Negras__c> lstNuevosRegistros;

  // Registros Antiguos
  final Map<Id, IN_Reporte_de_Listas_Negras__c> mapViejosRegistros;

  // Identificador del usuario actual
  final String strIdUser = UserInfo.getUserId();

  // Identificador del perfil del usuario actual
  final String strIdProfile = UserInfo.getProfileId();

  // Nombre del perfil del usuario actual
  final Profile objProfile = [ SELECT Name FROM Profile WHERE Id = :strIdProfile];

  // Nombre del status activo para la cuenta
  final String strActivoCuenta = Label.IN_ListaNegraHandler_cls_var_001;

  // Nombre del estado Boletinado
  final String strBoletinado = Label.IN_ListaNegraHandler_cls_var_002;

  // Nombre del estado Boletinado Previamente
  final String strBoletinadoPrev = Label.IN_ListaNegraHandler_cls_var_003;

  // Mensajes Validaciones
  final String strMensajeValidacion0 = Label.IN_ListaNegraHandler_cls_msg_000;
  final String strMensajeValidacion1 = Label.IN_ListaNegraHandler_cls_msg_001;
  final String strMensajeValidacion2 = Label.IN_ListaNegraHandler_cls_msg_002;
  final String strMensajeValidacion3 = Label.IN_ListaNegraHandler_cls_msg_003;
  final String strMensajeValidacion4 = Label.IN_ListaNegraHandler_cls_msg_004;
  final String strMensajeValidacion5 = Label.IN_ListaNegraHandler_cls_msg_005;
  final String strMensajeValidacion6 = Label.IN_ListaNegraHandler_cls_msg_006;
  final String strMensajeValidacion7 = Label.IN_ListaNegraHandler_cls_msg_007;
  final String strMensajeValidacion8 = Label.IN_ListaNegraHandler_cls_msg_008;
  final String strMensajeValidacion10 = Label.IN_ListaNegraHandler_cls_var_010;
  final String strMensajeValidacionGrupo1 = Label.IN_ListaNegraHandler_cls_Gpo_001;


  // Perfiles para manejar la lista negra
  final Set<String> setPerfiles = new Set<String>{Label.IN_ListaNegraHandler_cls_perfiles_001, Label.IN_ListaNegraHandler_cls_perfiles_002, Label.IN_ListaNegraHandler_cls_perfiles_003};

  // Valor para la creacion de cuenta de tipo persona fisica
  final String strPersonaFisica = Label.IN_ListaNegraHandler_cls_var_004;

  // Valor para la creacion de cuenta de tipo persona fisica no vigente
  final String strPersonaFisicaNoVigente = Label.IN_ListaNegraHandler_cls_var_013;

    // Valor para la creacion de cuenta de tipo Cliente Corporativo CP
    final String strClienteCorporativoCP = Label.IN_ListaNegraHandler_cls_var_014;

  // Valor para la creacion de cuenta de tipo persona moral
  final String strPersonaMoral = Label.IN_ListaNegraHandler_cls_var_005;

  // Valor para la creacion de cuenta de tipo persona moral No vigente
  final String strPersonaMoralNoVigente = Label.IN_ListaNegraHandler_cls_var_011;

  // Valor para la creacion de cuenta de tipo Cliente Corporativo
  final String strClienteCorporativo = Label.IN_ListaNegraHandler_cls_var_012;

  // Identificador tipo de registro cuenta fisica
  final RecordType objPersonaFisica = [
    SELECT Id, DeveloperName
    FROM RecordType
    WHERE SobjectType =:Label.IN_ListaNegraHandler_cls_var_006 AND DeveloperName =:Label.IN_ListaNegraHandler_cls_var_007
    LIMIT 1
  ];

  // Identificador tipo de registro cuenta fisica No Vigente
  final RecordType objPersonaFisicaNoVigente = [
    SELECT Id, DeveloperName
    FROM RecordType
    WHERE SobjectType =:Label.IN_ListaNegraHandler_cls_var_006 AND DeveloperName =:Label.IN_ListaNegraHandler_cls_var_013
    LIMIT 1
  ];

  // Identificador tipo de registro Cliente Corporativo CP
  final RecordType objClienteCorporativoCP = [
    SELECT Id, DeveloperName
    FROM RecordType
    WHERE SobjectType =:Label.IN_ListaNegraHandler_cls_var_006 AND DeveloperName =:Label.IN_ListaNegraHandler_cls_var_014
    LIMIT 1
  ];

  // Identificador tipo de registro cuenta moral
  final RecordType objPersonaMoral = [
    SELECT Id, DeveloperName
    FROM RecordType
    WHERE SObjectType =:Label.IN_ListaNegraHandler_cls_var_006 AND DeveloperName =:Label.IN_ListaNegraHandler_cls_var_008
    LIMIT 1
  ];

  // Identificador tipo de registro cuenta moral no vigente
  final RecordType objPersonaMoralNoVigente = [
    SELECT Id, DeveloperName
    FROM RecordType
    WHERE SObjectType =:Label.IN_ListaNegraHandler_cls_var_006 AND DeveloperName =:Label.IN_ListaNegraHandler_cls_var_011
    LIMIT 1
  ];

  // Identificador tipo de registro Cliente Corporativo
  final RecordType objClienteCorporativo = [
    SELECT Id, DeveloperName
    FROM RecordType
    WHERE SObjectType =:Label.IN_ListaNegraHandler_cls_var_006 AND DeveloperName =:Label.IN_ListaNegraHandler_cls_var_012
    LIMIT 1
  ];

  // Grupo Lista Negra
  final Group objGroup = [
    SELECT Id, DeveloperName
    FROM Group
    WHERE DeveloperName =:Label.IN_ListaNegraHandler_cls_var_009
    LIMIT 1
  ];

  // Constructor de la clase
  public IN_ListaNegraHandler_cls(List<IN_Reporte_de_Listas_Negras__c> lstNuevosRegistros, Map<Id, IN_Reporte_de_Listas_Negras__c> mapViejosRegistros) {
      this.lstNuevosRegistros = lstNuevosRegistros;
      this.mapViejosRegistros = mapViejosRegistros;
  }

  /*
   * Proceso para mapear en un wrapper los registros nuevos por cuenta asociada,
   * no asociada, registros previos, informacion de la cuenta asociada.
   */
  public WrapperDatos informacionListaNegra() {

    WrapperDatos wrpDatos = new WrapperDatos();

    // Mapa donde se guardan los registros de lista negra nuevos y que estan asociadas a un cuenta por TAM_IdExternoNombre__c
    Map<String, List<IN_Reporte_de_Listas_Negras__c>> mapConjuntoNuevoLN = new Map<String, List<IN_Reporte_de_Listas_Negras__c>>();

    // Mapa donde se guardan los registros de lista negra ya registrados asociados a la cuenta por TAM_IdExternoNombre__c
    Map<String, List<IN_Reporte_de_Listas_Negras__c>> mapConjuntoGuardadoLN = new Map<String, List<IN_Reporte_de_Listas_Negras__c>>();

    // Mapa donde se guardan los registros de lista negra que no tienen cuenta asociada por nombre de la cuenta que se capturo
    Map<String, List<IN_Reporte_de_Listas_Negras__c>> mapCuentaCreada = new Map<String, List<IN_Reporte_de_Listas_Negras__c>>();

    // Mapa donde se guarda la union de los mapas mapConjuntoNuevoLN y mapCuentaCreada
    Map<String, List<IN_Reporte_de_Listas_Negras__c>> mapUnion = new Map<String, List<IN_Reporte_de_Listas_Negras__c>>();

    // Mapa donde se guarda la información de la cuenta por TAM_IdExternoNombre__c
    Map<String, Account> mapConjuntoAccount = new Map<String, Account>();

    // Set donde se guarda solamente los TAM_IdExternoNombre__c de los reportes de lista negra
    Set<String> setConjunto = new Set<String>();

    // Set donde se guardan solamente los Identificadores de la cuenta de  los reportes de lista negra
    Set<String> setIdAccount = new Set<String>();

    for(IN_Reporte_de_Listas_Negras__c obj : lstNuevosRegistros) {

      // Tiene cuenta asociada
      if (obj.IN_ConjuntoCampos__c != null) {

        if(mapConjuntoNuevoLN.get(obj.IN_ConjuntoCampos__c) != null) {
          List<IN_Reporte_de_Listas_Negras__c> lstLN = mapConjuntoNuevoLN.get(obj.IN_ConjuntoCampos__c);
          lstLN.add(obj);
          mapConjuntoNuevoLN.put(obj.IN_ConjuntoCampos__c, lstLN);
        } else {
          List<IN_Reporte_de_Listas_Negras__c> lstLN = new List<IN_Reporte_de_Listas_Negras__c>();
          lstLN.add(obj);
          mapConjuntoNuevoLN.put(obj.IN_ConjuntoCampos__c, lstLN);
        }

      // No tiene cuenta asociada
      } else {

        if (obj.IN_Nombre_de_la_cuenta_text__c != null) {
          String sNombreCtaCreada = obj.IN_Nombre_de_la_cuenta_text__c.toUpperCase();
          obj.IN_Nombre_de_la_cuenta_text__c = sNombreCtaCreada;
          if(mapCuentaCreada.get(obj.IN_Nombre_de_la_cuenta_text__c) != null) {
            List<IN_Reporte_de_Listas_Negras__c> lstLN = mapCuentaCreada.get(obj.IN_Nombre_de_la_cuenta_text__c);
            lstLN.add(obj);
            mapCuentaCreada.put(obj.IN_Nombre_de_la_cuenta_text__c, lstLN);
          } else {
            List<IN_Reporte_de_Listas_Negras__c> lstLN = new List<IN_Reporte_de_Listas_Negras__c>();
            lstLN.add(obj);
            mapCuentaCreada.put(obj.IN_Nombre_de_la_cuenta_text__c, lstLN);
          }
        }
      }
    }

    wrpDatos.mapCuentaCreada = mapCuentaCreada;
    wrpDatos.mapConjuntoNuevoLN = mapConjuntoNuevoLN;

    // Si tiene cuenta asociada, busca si tiene ya registros guardados
    if (mapConjuntoNuevoLN.size() > 0) {

      setConjunto = mapConjuntoNuevoLN.keySet();

      List<Account> lstAccount = [
        SELECT Id, TAM_IdExternoNombre__c, CreatedDate, OwnerId, IN_Estatus__c, IN_Estatus__pc
        FROM Account
        WHERE TAM_IdExternoNombre__c IN :setConjunto
        ORDER BY CreatedDate ASC
      ];

      for (Account a : lstAccount) {
        setIdAccount.add(a.Id);
        mapConjuntoAccount.put(a.TAM_IdExternoNombre__c, a);
      }

      List<IN_Reporte_de_Listas_Negras__c> lstListaNegra = [
        SELECT Id, IN_Nombre_de_la_Cuenta__c, IN_Estatus__c, IN_ConjuntoCampos__c
        FROM IN_Reporte_de_Listas_Negras__c
        WHERE IN_Nombre_de_la_Cuenta__c IN :setIdAccount
        ORDER BY CreatedDate DESC
      ];

      for (IN_Reporte_de_Listas_Negras__c obj : lstListaNegra) {
        if (obj.IN_ConjuntoCampos__c != null) {
          if(mapConjuntoGuardadoLN.get(obj.IN_ConjuntoCampos__c) != null) {
            List<IN_Reporte_de_Listas_Negras__c> lstLN = mapConjuntoGuardadoLN.get(obj.IN_ConjuntoCampos__c);
            lstLN.add(obj);
            mapConjuntoGuardadoLN.put(obj.IN_ConjuntoCampos__c, lstLN);
          } else {
            List<IN_Reporte_de_Listas_Negras__c> lstLN = new List<IN_Reporte_de_Listas_Negras__c>();
            lstLN.add(obj);
            mapConjuntoGuardadoLN.put(obj.IN_ConjuntoCampos__c, lstLN);
          }
        }
      }
      wrpDatos.mapConjuntoGuardadoLN = mapConjuntoGuardadoLN;
    }

    // Se unen los mapas mapConjuntoNuevoLN y mapCuentaCreada
    for (String key : mapCuentaCreada.keySet()) {
      List<IN_Reporte_de_Listas_Negras__c> lstLNtemp = mapCuentaCreada.get(key);
      mapUnion.put(key, lstLNtemp);
    }

    for (String key : mapConjuntoNuevoLN.keySet()) {
      List<IN_Reporte_de_Listas_Negras__c> lstLNtemp = mapConjuntoNuevoLN.get(key);
      mapUnion.put(key, lstLNtemp);
    }

    wrpDatos.mapUnion = mapUnion;
    wrpDatos.mapConjuntoAccount = mapConjuntoAccount;

    return wrpDatos;
  }

  /**
   * Proceso para crear las cuentas ligadas al reporte de lista negra
   *
   * @param IN_Reporte_de_Listas_Negras__c obj Objeto de Reporte de lista Negra
   *
   * @return Account
   */
  public Account operacionCuenta(IN_Reporte_de_Listas_Negras__c obj) {

    Account objAccount = new Account();

    // Persona Fisica
    if (obj.IN_Tipo_de_Persona__c == strPersonaFisica) {

      List<String> lstNombreCompleto = obj.IN_Nombre_de_la_cuenta_text__c.split(' ');

      Integer intTamNombre = lstNombreCompleto.size();

      String strApellidos ='';

      objAccount.FirstName = lstNombreCompleto.get(0).toUpperCase();
	    //objAccount.FirstName = lstNombreCompleto.get(0);
	  
      if (intTamNombre > 1) {
        for(Integer i = 1; i < intTamNombre; i++){
          strApellidos += lstNombreCompleto.get(i)+' ';
        }
      }
      strApellidos = strApellidos.removeEnd(' ').toUpperCase();
      //strApellidos = strApellidos.removeEnd(' ');
      objAccount.LastName = strApellidos.toUpperCase();
      //objAccount.LastName = strApellidos;
      objAccount.IN_RFC__pc = obj.IN_RFC__c;
      objAccount.IN_Calle__pc = obj.IN_Calle_RLN__c;
      objAccount.IN_Colonia__pc = obj.IN_Colonia_RLN__c;
      objAccount.IN_Codigo_Postal__pc = obj.IN_Codigo_Postal_RLN__c;
      objAccount.IN_Comentario_de_Lista_Negra__pc = obj.IN_Comentario_de_Listas_Negras__c;
      objAccount.IN_Estatus__pc = obj.IN_Estatus__c;
	    objAccount.IN_Estatus__c = obj.IN_Estatus__c;      
      objAccount.IN_N_mero_Interior__pc = obj.IN_No_Interior_RLN__c;
      objAccount.IN_Numero_Exterior__pc = obj.IN_No_Exterior_RLN__c;
      objAccount.IN_Razon__c = obj.IN_Razon__c;
      objAccount.IN_Salvado_por_DTM__pc = obj.IN_Salvado__c;
      objAccount.IN_Salvado_por_DTM__c = obj.IN_Salvado__c;      
      objAccount.Website = obj.Sitio_web__c;
      objAccount.IN_Telefono__c = obj.IN_Telefono_RLN__c;
      objAccount.IN_Tipo_de_Persona__pc = obj.IN_Tipo_de_Persona__c;
      objAccount.RecordTypeId = objPersonaFisica.Id;
      
      //Agrega los datos de la dirección al objeto de la cuenta
      objAccount.BillingStreet = obj.IN_Calle_RLN__c != null ? obj.IN_Calle_RLN__c.toUpperCase() : null;
      objAccount.Colonia__c = obj.IN_Colonia_RLN__c != null ? obj.IN_Colonia_RLN__c.toUpperCase() : null;
      objAccount.BillingCity = obj.IN_Municipio__c != null ? obj.IN_Municipio__c.toUpperCase() : null; 
      objAccount.BillingState = obj.IN_Estado__c != null ? obj.IN_Estado__c.toUpperCase() : null ;
      objAccount.BillingPostalCode = obj.IN_Codigo_Postal_RLN__c;
      objAccount.Phone = obj.IN_Telefono_RLN__c;
      objAccount.RFC__c = obj.IN_RFC__c != null ? obj.IN_RFC__c.toUpperCase() : null ;       
    }

    // Persona Moral
    if (obj.IN_Tipo_de_Persona__c == strPersonaMoral) {
      objAccount.Name = obj.IN_Nombre_de_la_cuenta_text__c != null ? obj.IN_Nombre_de_la_cuenta_text__c.toUpperCase() : obj.IN_Nombre_de_la_cuenta_text__c;
      //objAccount.Name = obj.IN_Nombre_de_la_cuenta_text__c != null ? obj.IN_Nombre_de_la_cuenta_text__c : obj.IN_Nombre_de_la_cuenta_text__c;
      objAccount.IN_RFC__c = obj.IN_RFC__c;
      objAccount.IN_Calle__c = obj.IN_Calle_RLN__c;
      objAccount.Colonia__c = obj.IN_Colonia_RLN__c;
      objAccount.Codigo_Postal__c = obj.IN_Codigo_Postal_RLN__c;
      objAccount.IN_Comentario_de_Lista_Negra__c = obj.IN_Comentario_de_Listas_Negras__c;
      objAccount.IN_Estatus__c = obj.IN_Estatus__c;
      objAccount.Numero_Interior__c = obj.IN_No_Interior_RLN__c;
      objAccount.Numero_Exterior__c = obj.IN_No_Exterior_RLN__c;
      objAccount.IN_Razon__c = obj.IN_Razon__c;
      objAccount.IN_Salvado_por_DTM__c = obj.IN_Salvado__c;
      objAccount.Website = obj.Sitio_web__c;
      objAccount.IN_Telefono__c = obj.IN_Telefono_RLN__c;
      objAccount.IN_Tipo_de_Persona__c = obj.IN_Tipo_de_Persona__c;
      objAccount.RecordTypeId = objPersonaMoral.Id;
      
      //Agrega los datos de la dirección al objeto de la cuenta
      objAccount.BillingStreet = obj.IN_Calle_RLN__c != null ? obj.IN_Calle_RLN__c.toUpperCase() : null;
      objAccount.Colonia__c = obj.IN_Colonia_RLN__c != null ? obj.IN_Colonia_RLN__c.toUpperCase() : null;
      objAccount.BillingCity = obj.IN_Municipio__c != null ? obj.IN_Municipio__c.toUpperCase() : null; 
      objAccount.BillingState = obj.IN_Estado__c != null ? obj.IN_Estado__c.toUpperCase() : null ;
      objAccount.BillingPostalCode = obj.IN_Codigo_Postal_RLN__c;
      objAccount.Phone = obj.IN_Telefono_RLN__c;
      objAccount.RFC__c = obj.IN_RFC__c != null ? obj.IN_RFC__c.toUpperCase() : null ;      

    }

    return objAccount;

  }

  /**
   * Proceso para los cambios de status de Boletinado en lista negra y cuentas
   *
   * @return void
   */
  public void clienteBoletinado() {

    // En caso de creación
    if (lstNuevosRegistros.size() > 0 && mapViejosRegistros == null) {

      Map<String, List<IN_Reporte_de_Listas_Negras__c>> mapAccountLN = new Map<String, List<IN_Reporte_de_Listas_Negras__c>>();
      Set<String> setINCampoAccount = new Set<String>();

      for (IN_Reporte_de_Listas_Negras__c obj : lstNuevosRegistros) {

        // No existen las cuentas
        if (obj.IN_Nombre_de_la_cuenta_text__c != null) {

          String strNombreCuenta = obj.IN_Nombre_de_la_cuenta_text__c;

          String strTipoPersona = '';

          //Cliente Persona Moral
          if (obj.IN_Tipo_de_Persona__c == strPersonaMoral) {
            strTipoPersona = objPersonaMoral.Id;
          }

          //Cliente Persona Moral No Vigente
          if (obj.IN_Tipo_de_Persona__c == strPersonaMoralNoVigente) {
            strTipoPersona = objPersonaMoralNoVigente.Id;
          }

          //Cliente Corporativo
          if (obj.IN_Tipo_de_Persona__c == strClienteCorporativo) {
            strTipoPersona = objClienteCorporativo.Id;
          }

          //Cliente Persona Fisica
          if (obj.IN_Tipo_de_Persona__c == strPersonaFisica) {
            strTipoPersona = objPersonaFisica.Id;
          }

          //Cliente Persona Fisica No Vigente
          if (obj.IN_Tipo_de_Persona__c == strPersonaFisicaNoVigente) {
            strTipoPersona = objPersonaFisicaNoVigente.Id;
          }

           //Cliente Corporativo CP
           if (obj.IN_Tipo_de_Persona__c == strClienteCorporativoCP) {
            strTipoPersona = objClienteCorporativoCP.Id;
          }
		
		      System.debug('EN clienteBoletinado strTipoPersona0: ' + strTipoPersona);
          strTipoPersona = strTipoPersona.length() > 15 ? strTipoPersona.substring(0,15) : strTipoPersona.substring(0, strTipoPersona.length());
		      System.debug('EN clienteBoletinado strTipoPersona1: ' + strTipoPersona);
		            
          //String strINCampo = strNombreCuenta+strTipoPersona;
          String strINCampo = strNombreCuenta;

          if (mapAccountLN.get(strINCampo) != null) {
            List<IN_Reporte_de_Listas_Negras__c> lstTemp = mapAccountLN.get(strINCampo);
            lstTemp.add(obj);
            mapAccountLN.put(strINCampo, lstTemp);
          } else {
            List<IN_Reporte_de_Listas_Negras__c> lstTemp = new List<IN_Reporte_de_Listas_Negras__c>();
            lstTemp.add(obj);
            mapAccountLN.put(strINCampo, lstTemp);
          }
        // Existen las cuentas
        } else {
          if (mapAccountLN.get(obj.IN_ConjuntoCampos__c) != null) {
            List<IN_Reporte_de_Listas_Negras__c> lstTemp = mapAccountLN.get(obj.IN_ConjuntoCampos__c);
            lstTemp.add(obj);
            mapAccountLN.put(obj.IN_ConjuntoCampos__c, lstTemp);
          } else {
            List<IN_Reporte_de_Listas_Negras__c> lstTemp = new List<IN_Reporte_de_Listas_Negras__c>();
            lstTemp.add(obj);
            mapAccountLN.put(obj.IN_ConjuntoCampos__c, lstTemp);
          }
        }
      }

      setINCampoAccount = mapAccountLN.keySet();
	    System.debug('EN clienteBoletinado objAccount.setINCampoAccount: ' + setINCampoAccount);

      List<Account> lstAccount = [
        SELECT Id, TAM_IdExternoNombre__c, CreatedDate, OwnerId, IN_Estatus__c, RecordTypeId,
        PersonContactId, IN_RFC__c, IN_Calle__pc, Colonia__c, IN_N_mero_Interior__pc, IN_Numero_Exterior__pc,
        IN_Codigo_Postal__pc, IN_Telefono__c, Website, IN_Calle__c, Numero_Interior__c,
        Numero_Exterior__c, Codigo_Postal__c, IN_Colonia__pc, IN_RFC__pc
        FROM Account
        WHERE TAM_IdExternoNombre__c IN :setINCampoAccount
        ORDER BY CreatedDate ASC
      ];
	    System.debug('EN clienteBoletinado objAccount.lstAccount: ' + lstAccount);

      List<IN_Reporte_de_Listas_Negras__c> lstListaNegra = new List<IN_Reporte_de_Listas_Negras__c>();
      Set<IN_Reporte_de_Listas_Negras__c> setListaNegra = new Set<IN_Reporte_de_Listas_Negras__c>();
      Map<String, IN_Reporte_de_Listas_Negras__c> mapListaNegra = new Map<String, IN_Reporte_de_Listas_Negras__c>();

      List<Account> lstActualizarAccount = new List<Account>();
      Set<Account> setAccount = new Set<Account>();

      for (Account objAccount : lstAccount) {
      	System.debug('EN clienteBoletinado objAccount.TAM_IdExternoNombre__c: ' + objAccount.TAM_IdExternoNombre__c + ' keySet(): ' + mapAccountLN.keySet() + ' Values(); ' + mapAccountLN.Values());
      	
      	/*List<IN_Reporte_de_Listas_Negras__c> lstLNTemp = new List<IN_Reporte_de_Listas_Negras__c>();
      	for (String sNombrePaso : mapAccountLN.keySet()){
      		String sNameAccPaso = sNombrePaso;
      		sNameAccPaso = sNameAccPaso.toUpperCase();  
      		if (sNombrePaso == objAccount.TAM_IdExternoNombre__c)
				lstLNTemp.addAll(mapAccountLN.get(sNombrePaso));      		    		
      	}
		    System.debug('EN clienteBoletinado lstLNTemp: ' + lstLNTemp);*/ 
		     	
        //List<IN_Reporte_de_Listas_Negras__c> lstLNTemp = mapAccountLN.containsKey(objAccount.TAM_IdExternoNombre__c) ? mapAccountLN.get(objAccount.TAM_IdExternoNombre__c) : new List<IN_Reporte_de_Listas_Negras__c>();
     	  List<IN_Reporte_de_Listas_Negras__c> lstLNTemp = new List<IN_Reporte_de_Listas_Negras__c>();
      	for (String sNombrePaso : mapAccountLN.keySet()){
      		List<IN_Reporte_de_Listas_Negras__c> lstLNTempPaso = mapAccountLN.get(sNombrePaso);
      		if (!lstLNTempPaso.isEmpty())
      			lstLNTemp.addAll(mapAccountLN.get(sNombrePaso));
      	}
        System.debug('EN clienteBoletinado lstLNTemp: ' + lstLNTemp);
        
        for (IN_Reporte_de_Listas_Negras__c objLN : lstLNTemp) {
          IN_Reporte_de_Listas_Negras__c objLNTemp = new IN_Reporte_de_Listas_Negras__c(Id = objLN.Id);
          objLNTemp.IN_Nombre_de_la_Cuenta__c = objAccount.Id;
          objLNTemp.IN_Estatus__c = (objLNTemp.IN_Estatus__c != null) ? objLNTemp.IN_Estatus__c : strBoletinado;
          objLNTemp.IN_Nombre_del_Contacto__c = objAccount.PersonContactId;
          objLNTemp.IN_Telefono_RLN__c = objAccount.IN_Telefono__c;
          objLNTemp.Sitio_web__c = objAccount.Website;

          // Persona Fisica
          if (objAccount.RecordTypeId == objPersonaFisica.Id || objAccount.RecordTypeId == objPersonaFisicaNoVigente.Id || objAccount.RecordTypeId == objClienteCorporativoCP.Id) {

            objLNTemp.IN_Calle_RLN__c = objAccount.IN_Calle__pc;
            objLNTemp.IN_Colonia_RLN__c = objAccount.IN_Colonia__pc;
            objLNTemp.IN_No_Interior_RLN__c = objAccount.IN_N_mero_Interior__pc;
            objLNTemp.IN_No_Exterior_RLN__c = objAccount.IN_Numero_Exterior__pc;
            objLNTemp.IN_Codigo_Postal_RLN__c = objAccount.IN_Codigo_Postal__pc;
            objLNTemp.IN_RFC__c = objAccount.IN_RFC__pc;
            
            objAccount.IN_Estatus__pc = strBoletinado;
	  		    objAccount.IN_Estatus__c = strBoletinado;            
            objAccount.IN_Razon__c = objLN.IN_Razon__c;
            objAccount.IN_Comentario_de_Lista_Negra__pc = objLN.IN_Comentario_de_Listas_Negras__c;
            objAccount.IN_Salvado_por_DTM__c = false;
            
            lstActualizarAccount.add(objAccount);

          // Persona Moral - Cliente Persona Moral No Vigente - Cliente Corporativo
          } else if (objAccount.RecordTypeId == objPersonaMoral.Id || objAccount.RecordTypeId == objPersonaMoralNoVigente.Id || objAccount.RecordTypeId == objClienteCorporativo.Id) {

            objLNTemp.IN_Calle_RLN__c = objAccount.IN_Calle__c;
            objLNTemp.IN_Colonia_RLN__c = objAccount.Colonia__c;
            objLNTemp.IN_No_Interior_RLN__c = objAccount.Numero_Interior__c;
            objLNTemp.IN_No_Exterior_RLN__c = objAccount.Numero_Exterior__c;
            objLNTemp.IN_Codigo_Postal_RLN__c = objAccount.Codigo_Postal__c;
            objLNTemp.IN_RFC__c = objAccount.IN_RFC__c;
			
            objAccount.IN_Estatus__c = strBoletinado;
            objAccount.IN_Razon__c = objLN.IN_Razon__c;
            objAccount.IN_Comentario_de_Lista_Negra__c = objLN.IN_Comentario_de_Listas_Negras__c;
            objAccount.IN_Salvado_por_DTM__c = false;
            lstActualizarAccount.add(objAccount);
          }


          mapListaNegra.put(objLNTemp.Id, objLNTemp);
          setListaNegra.add(objLNTemp);
        }
      }

      for (String key : mapListaNegra.keySet()) {
        IN_Reporte_de_Listas_Negras__c objLN = mapListaNegra.get(key);
        lstListaNegra.add(objLN);
      }

      setAccount.addAll(lstActualizarAccount);
      lstActualizarAccount = new List<Account>();
      lstActualizarAccount.addAll(setAccount);

      List<AccountShare> lstAccountShare = new List<AccountShare>();

      for (Account objAccountTemp : lstActualizarAccount) {
        AccountShare objAccountShare = new AccountShare();
        objAccountShare.AccountAccessLevel = 'Edit';
        objAccountShare.AccountId	= objAccountTemp.Id;
        objAccountShare.CaseAccessLevel =	'None';
        objAccountShare.OpportunityAccessLevel = 'None';
        objAccountShare.UserOrGroupId	= objGroup.Id;
        lstAccountShare.add(objAccountShare);
      }


      System.debug('EN clienteBoletinado lstListaNegra: ' + lstListaNegra);
      update lstListaNegra;
      System.debug('EN clienteBoletinado lstActualizarAccount: ' + lstActualizarAccount);
      update lstActualizarAccount;
      System.debug('EN clienteBoletinado lstAccountShare: ' + lstAccountShare);
      insert lstAccountShare;

    // En caso de actualización
    } else {
      Set<String> setAccountSalvado = new Set<String>();
      Set<String> setAccountModificar = new Set<String>();
      Map<String, IN_Reporte_de_Listas_Negras__c> mapSalvadoLN = new Map<String, IN_Reporte_de_Listas_Negras__c>();

      Map<String, List<IN_Reporte_de_Listas_Negras__c>> mapAccountActualizar = new Map<String, List<IN_Reporte_de_Listas_Negras__c>>();

      for (IN_Reporte_de_Listas_Negras__c obj : lstNuevosRegistros) {

        IN_Reporte_de_Listas_Negras__c objLNViejo = mapViejosRegistros.get(obj.Id);

        if (obj.IN_Salvado__c) {
          setAccountSalvado.add(obj.IN_Nombre_de_la_Cuenta__c);
          mapSalvadoLN.put(obj.IN_Nombre_de_la_Cuenta__c, obj);
        }

        if (obj.IN_Estatus__c != objLNViejo.IN_Estatus__c && obj.IN_Salvado__c == false) {
          setAccountModificar.add(obj.IN_Nombre_de_la_Cuenta__c);
        }
      }

      List<IN_Reporte_de_Listas_Negras__c> lstLNBoletinado = [
        SELECT IN_Nombre_de_la_Cuenta__c, IN_Estatus__c, IN_Comentario_de_Listas_Negras__c 
        FROM IN_Reporte_de_Listas_Negras__c
        WHERE IN_Nombre_de_la_Cuenta__c IN :setAccountModificar
      ];

      if (setAccountSalvado.size() > 0 ) {

        List<Account> lstAccountSalvado = [
          SELECT Id, RecordTypeId, IN_Estatus__c
          FROM Account
          WHERE Id IN :setAccountSalvado
        ];
        List<Account> lstActivo = new List<Account>();

        for (Account objAccount : lstAccountSalvado) {
          IN_Reporte_de_Listas_Negras__c objLNTemp = mapSalvadoLN.get(objAccount.Id);
          // Persona Fisica
          if (objAccount.RecordTypeId == objPersonaFisica.Id || objAccount.RecordTypeId == objPersonaFisicaNoVigente.Id || objAccount.RecordTypeId == objClienteCorporativoCP.Id) {
            objAccount.IN_Estatus__pc = strActivoCuenta;
	  		objAccount.IN_Estatus__c = strActivoCuenta;            
            objAccount.IN_Salvado_por_DTM__pc = true;
      		objAccount.IN_Salvado_por_DTM__c = true;            
            objAccount.IN_Comentario_de_Lista_Negra__pc = objLNTemp.IN_Comentario_de_Listas_Negras__c;
            lstActivo.add(objAccount);
          // Persona Moral
          } else if (objAccount.RecordTypeId == objPersonaMoral.Id || objAccount.RecordTypeId == objPersonaMoralNoVigente.Id || objAccount.RecordTypeId == objClienteCorporativo.Id) {
            objAccount.IN_Estatus__c = strActivoCuenta;
            objAccount.IN_Salvado_por_DTM__c = true;
            objAccount.IN_Comentario_de_Lista_Negra__c = objLNTemp.IN_Comentario_de_Listas_Negras__c;
            lstActivo.add(objAccount);
          }
        }
        update lstActivo;

      }

      if (setAccountModificar.size() > 0 ) {

        Map<String, Set<String>> mapAccountLNStatus = new Map<String, Set<String>>();
        Map<String, IN_Reporte_de_Listas_Negras__c> mapLNModificar = new Map<String, IN_Reporte_de_Listas_Negras__c>();

        Set<String> setAccountStatus = new Set<String>();

        List<String> lstIdAccount = new List<String>();

        for(IN_Reporte_de_Listas_Negras__c obj : lstLNBoletinado) {

          mapLNModificar.put(obj.IN_Nombre_de_la_Cuenta__c, obj);

          if (mapAccountLNStatus.get(obj.IN_Nombre_de_la_Cuenta__c) != null) {
            Set<String> setTemp = mapAccountLNStatus.get(obj.IN_Nombre_de_la_Cuenta__c);
            setTemp.add(obj.IN_Estatus__c);
            mapAccountLNStatus.put(obj.IN_Nombre_de_la_Cuenta__c, setTemp);
          } else {
            Set<String> setTemp = new Set<String>();
            setTemp.add(obj.IN_Estatus__c);
            mapAccountLNStatus.put(obj.IN_Nombre_de_la_Cuenta__c, setTemp);
          }
        }

        for (String key : mapAccountLNStatus.keySet()) {
          Set<String> setTemp = mapAccountLNStatus.get(key);
          Boolean blnBoletinado = setTemp.contains(strBoletinado);
          if (blnBoletinado == false) {
            lstIdAccount.add(key);
          }
        }

        List<Account> lstAccountBoletinadoPrev = [
          SELECT Id, RecordTypeId, IN_Estatus__c, IN_Estatus__pc, IN_Comentario_de_Lista_Negra__pc, IN_Comentario_de_Lista_Negra__c
          FROM Account
          WHERE Id IN :lstIdAccount
        ];

        List<Account> lstAccountActualizar = new List<Account>();
        for (Account objAccount : lstAccountBoletinadoPrev) {
          IN_Reporte_de_Listas_Negras__c objLNTemp = mapLNModificar.get(objAccount.Id);
          System.debug('*** objLNTemp '+objLNTemp);

          // Persona Fisica
          if (objAccount.RecordTypeId == objPersonaFisica.Id || objAccount.RecordTypeId == objPersonaFisicaNoVigente.Id || objAccount.RecordTypeId == objClienteCorporativoCP.Id) {
            objAccount.IN_Estatus__pc = strBoletinadoPrev;
	  		    objAccount.IN_Estatus__c = strBoletinadoPrev;            
            objAccount.IN_Comentario_de_Lista_Negra__pc = objLNTemp.IN_Comentario_de_Listas_Negras__c;
            lstAccountActualizar.add(objAccount);
          // Persona Moral - Cliente Persona Moral No Vigente
          } else if (objAccount.RecordTypeId == objPersonaMoral.Id || objAccount.RecordTypeId == objPersonaMoralNoVigente.Id || objAccount.RecordTypeId == objClienteCorporativo.Id) {
            objAccount.IN_Estatus__c = strBoletinadoPrev;
            objAccount.IN_Comentario_de_Lista_Negra__c = objLNTemp.IN_Comentario_de_Listas_Negras__c;
            lstAccountActualizar.add(objAccount);
          }
        }
        update(lstAccountActualizar);
      }

    }

  }

  /**
   * Proceso de validación en el reporte de lista negra
   *
   * @param Boolean blnCrea Indica si la validacion es para insertar(true) o actualizar(false)
   *
   * @return void
   */
  public void validacionBoletinado(Boolean blnCrea) {

    // Obtiene el wrapper de la información de lista negra
    WrapperDatos wrpDatos = informacionListaNegra();

    // Nombres de las cuentas
    Set<String> setNombreAccount = new Set<String>();

    // RFC de las cuentas
    Set<String> setRFC = new Set<String>();

    // Nombre de las cuentas con los parametros de LIKE para la busqueda
    Set<String> setLikeNombreAccount = new Set<String>();

    // Validaciones sobre todos los registros nuevos
    if (wrpDatos.mapUnion.size() > 0 ) {

      for (String key : wrpDatos.mapUnion.keyset()) {
        List<IN_Reporte_de_Listas_Negras__c> lstLN = wrpDatos.mapUnion.get(key);
        for (IN_Reporte_de_Listas_Negras__c obj : lstLN) {

          // En caso que sea creación
          if (blnCrea) {
            // No se pueden crear registros con el estatus Boletinado Previamente
            if (obj.IN_Estatus__c == strBoletinadoPrev) {
              if (!Test.isRunningTest())		
              	obj.addError(strMensajeValidacion0);
              return;
            }
          }

          /** Generales **/

          // Nombre Cuenta y Nombre Cuenta Texto con datos
          if (obj.IN_Nombre_de_la_Cuenta__c != null && obj.IN_Nombre_de_la_cuenta_text__c != null) {
          	if (!Test.isRunningTest())
            	obj.addError(strMensajeValidacion6);
            return;
          }

          // No se puede Boletinar y Salvar al mismo tiempo
          if (obj.IN_Estatus__c == strBoletinado && obj.IN_Salvado__c) {
          	if (!Test.isRunningTest())
            	obj.addError(strMensajeValidacion1);
            return;
          }

          // Tipo de persona es fisica y no tiene apellidos
          if (obj.IN_Tipo_de_Persona__c == strPersonaFisica && obj.IN_Nombre_de_la_cuenta_text__c != null) {
            String strNombreFisico= obj.IN_Nombre_de_la_cuenta_text__c;
            List<String> lstNombreFisico = strNombreFisico.split(' ');
            if (lstNombreFisico.size() < 2 ) {
            	if (!Test.isRunningTest())		
            		obj.addError(strMensajeValidacion5);
              return;
            }
          }
        }
      }
    // Nombre Cuenta y Nombre Cuenta Texto no fue capturado
    } else {

      for (IN_Reporte_de_Listas_Negras__c obj : lstNuevosRegistros) {
        obj.addError(strMensajeValidacion7);
      }

    }

    // Validaciones en caso que existan cuentas relacionadas
    if (wrpDatos.mapConjuntoNuevoLN.size() > 0 ) {

      for (String key : wrpDatos.mapConjuntoNuevoLN.keySet()) {

        List<IN_Reporte_de_Listas_Negras__c> lstLN = wrpDatos.mapConjuntoNuevoLN.get(key);

        for(IN_Reporte_de_Listas_Negras__c obj : lstLN) {

          Account objAccount = new Account();  
          objAccount = wrpDatos.mapConjuntoAccount.containsKey(obj.IN_ConjuntoCampos__c) ? wrpDatos.mapConjuntoAccount.get(obj.IN_ConjuntoCampos__c) : new Account();
		  System.debug('EN validacionBoletinado objAccount: ' + objAccount);
		  
          // Que el perfil sea diferente de Usuario de DTM, que no sea dueño de la cuenta y que la cuenta este activa
          if(setPerfiles.contains(objProfile.Name) == false && objAccount.OwnerId != obj.OwnerId && (objAccount.IN_Estatus__c == strActivoCuenta || objAccount.IN_Estatus__pc == strActivoCuenta)) {
            obj.addError(strMensajeValidacion3);
            return;
          }

        }
      }
    }

    // Validaciones para la busqueda y creacion de la cuenta
    if (wrpDatos.mapCuentaCreada.size() > 0 ) {

      // Busqueda de la cuenta por el nombre
      setNombreAccount = wrpDatos.mapCuentaCreada.keySet();

      for (String strNombre : setNombreAccount) {
        // Nombre completo
        String strLike = '%'+strNombre+'%';
        setLikeNombreAccount.add(strLike);
      }

      List<Account> lstAccount = [
        SELECT Id, Name
        FROM Account
        WHERE TAM_IdExternoNombre__c LIKE :setLikeNombreAccount 
        AND (RecordTypeId =:objPersonaFisica.Id OR RecordTypeId =:objPersonaMoral.Id OR RecordTypeId =:objPersonaMoralNoVigente.Id 
        OR RecordTypeId =:objClienteCorporativo.Id OR RecordTypeId =:objPersonaFisicaNoVigente.Id OR RecordTypeId =:objClienteCorporativoCP.Id)
        LIMIT 5
      ];

      List<Account> lstNewAccount = new List<Account>();

      for (String key : wrpDatos.mapCuentaCreada.keySet()) {

        List<IN_Reporte_de_Listas_Negras__c> lstLNTemp = wrpDatos.mapCuentaCreada.get(key);

        for (IN_Reporte_de_Listas_Negras__c obj: lstLNTemp) {

          // Ya se encuentra posiblemente creada la cuenta
          if (lstAccount.size() > 0 ) {
			  System.debug('EN validacionBoletinado lstAccount: ' + lstAccount);
            //obj.addError(strMensajeValidacion2);
            //return;
          	// Se crea la cuenta
          } else {
			
			Integer iPosIni = 0;
			String sPosFin = Label.TAM_PosFinNomCtaBusqLN;
			Integer iPosFin = sPosFin.isNumeric() ? Integer.valueOf(sPosFin) : 0;

			//Ve si la persona en cuestion existe en la tabla de movimientos con una consulta de SOSL
			for (String sNombreBuscarPaso : setLikeNombreAccount){										
				String sNombreBuscarCons = sNombreBuscarPaso.replace('%', '');
				if ( (iPosIni + iPosFin) < sNombreBuscarCons.length() ){
					Integer iLong = (sNombreBuscarCons.length() - (iPosIni + iPosFin));
					System.debug('EN validacionBoletinado iLong: ' + iLong);
					if (iLong > 15)
						sNombreBuscarCons = sNombreBuscarCons.substring(iPosIni, iLong);
				}//Fin si (iPosIni + iPosFin) < sNombreBuscarCons.length()
				//Quita los caracteres 
			 	List<List<SObject>> searchList = [FIND :sNombreBuscarCons IN ALL FIELDS RETURNING Movimiento__c LIMIT 1];
			 	System.debug('EN validacionBoletinado sNombreBuscarCons: ' + sNombreBuscarCons + ' searchList: ' + searchList + ' searchList.isEmpty(): ' + searchList.isEmpty() + ' searchList.size(): ' + searchList.size());
				//Recorre la lista de busqueda searchList
				for (List<SObject> lsearchList : searchList){
					//Ve si tiene algo la lista de lsearchList
					if (lsearchList.isEmpty()){
				 		System.debug('EN validacionBoletinado NO ENCONTRO COINCIDENCIAS PARA sNombreBuscarCons2: ' + sNombreBuscarCons);
			            // Tipo de persona requerido cuando el campo de nombre de cuenta(texto) tiene valor
			            if (obj.IN_Nombre_de_la_cuenta_text__c != null && obj.IN_Tipo_de_Persona__c == null) {
			              obj.addError(strMensajeValidacion4);
			              return;
			            }
						//Crea el objeto del tipo Account para la nueva cuenta		
			            Account objCuentaNueva = operacionCuenta(obj);
			            lstNewAccount.add(objCuentaNueva);
					}//Fin si  lsearchList.isEmpty()
				 	if (!lsearchList.isEmpty()){
				 		System.debug('EN validacionBoletinado ENCONTRO COINCIDENCIAS PARA sNombreBuscarCons2: ' + sNombreBuscarCons);
				 		//Busca el grupo de DTM al que pertenece Edoardo y v alida si se trata de el para dejarlo pasar
				 		Set <String> setIdUsrDTMPaso = consultaGrupoDTM();
						System.debug('EN validacionBoletinado obj.OwnerId: ' + obj.OwnerId + ' ' + setIdUsrDTMPaso);				 		
				 		//Recorre los ID de los usuario y ve si uno coincide con el que esta haciendo la busqueda
				 		if (!setIdUsrDTMPaso.contains(obj.OwnerId)){
 	            			obj.addError(strMensajeValidacion10);
 	            			return;
				 		}//Fin si !setIdUsrDTMPaso.contains(obj.OwnerId)
				 		if (setIdUsrDTMPaso.contains(obj.OwnerId)){
				 			
				 			//Crea el objeto del tipo Account para la nueva cuenta		
			            	Account objCuentaNueva = operacionCuenta(obj);
			            	lstNewAccount.add(objCuentaNueva);
			            	//return;
			            	System.debug('EN validacionBoletinado es un usuario valido debe de dejar lstNewAccount: ' + lstNewAccount);
				 		}//Fin si 	setIdUsrDTMPaso.contains(obj.OwnerId))
				 	}//Fin si !lsearchList.isEmpty()					
				}//Fin del for searchList
				
			}//Fin del for para setLikeNombreAccount

          }//Fin si lstAccount.size() > 0 
          
        }//Fin del for para la lista de lstLNTemp
        
      }//Fin del for para el mapa de wrpDatos.mapCuentaCreada.keySet()
          
       //Ve si tiene algo la lista de lstNewAccount 
       if (lstNewAccount.size() > 0){
    	  System.debug('EN validacionBoletinado antes de crear la cuenta lstNewAccount: ' + lstNewAccount);
      	  if (!Test.isRunningTest())
        	upsert lstNewAccount;
        }          
       /** Fin Busqueda de la cuenta por el nombre **/
    }
    
  }

  public class WrapperDatos {
    // Mapa donde se almacenan los reportes de lista negra por IN_ConjuntoCampos__c
    public Map<String, List<IN_Reporte_de_Listas_Negras__c>> mapConjuntoNuevoLN{get;set;}
    // Mapa donde se almacenan los reportes de lista negra previamente guardados por IN_ConjuntoCampos__c
    public Map<String, List<IN_Reporte_de_Listas_Negras__c>> mapConjuntoGuardadoLN{get;set;}
    // Mapa donde se almacenan las cuentas que se van a crear
    public Map<String, List<IN_Reporte_de_Listas_Negras__c>> mapCuentaCreada{get;set;}
    // Mapa donde se unen los reportes de lista negra nuevos y por cuenta que se van a crear
    public Map<String, List<IN_Reporte_de_Listas_Negras__c>> mapUnion{get;set;}
    // Mapa donde se guarda la informacion de la cuenta por IN_ConjuntoCampos__c
    public Map<String, Account> mapConjuntoAccount{get;set;}
  }
  
  private set<string> consultaGrupoDTM(){
    System.debug('Entro a consultaGrupoDTM...');  	
  	set<String> idUsrGrupoDTM = new set<String>();
  	
  	//Consulta los datos de los grupos
  	for (Group grupoDTM : [Select g.Id, (Select GroupId, UserOrGroupId From GroupMembers) From Group g
			where Name = :strMensajeValidacionGrupo1
			order by Name desc]){
		System.debug('Entro a grupoDTM.GroupMembers.isEmpty(): ' + grupoDTM.GroupMembers.isEmpty());		
		//Ya tienes el id del grupo entonces bsusca a los usuario
		if (!grupoDTM.GroupMembers.isEmpty()){
			for(GroupMember GroupMembersPaso : grupoDTM.GroupMembers){
				System.debug('Entro a GroupMembersPaso.UserOrGroupId: ' + GroupMembersPaso.UserOrGroupId);
	  			//Mete los usaurios de DTM al set de idUsrGrupoDTM
	  			idUsrGrupoDTM.add(GroupMembersPaso.UserOrGroupId); 			
			}//Fin del for para grupoDTM.GroupMembers
		}//Fin si grupoDTM.GroupMembers.isEmpty()

  	}
  	
  	//Regrea la lista de usuario de DTM
  	return  idUsrGrupoDTM;
  	
  }
  
  
}